﻿Imports System.Collections.ObjectModel


Public Class AuthorInfo
    Implements IEquatable(Of AuthorInfo), IComparable(Of AuthorInfo)
    Public Sub New()
        Me.Creators = New ObservableCollection(Of String)()
        Me.Titles = New ObservableCollection(Of TitleInfo)()
    End Sub

    Private _creators As ObservableCollection(Of String)
    Public Property Creators() As ObservableCollection(Of String)
        Get
            Return _creators
        End Get
        Protected Set(ByVal value As ObservableCollection(Of String))
            _creators = value
        End Set
    End Property

    Private _titles As ObservableCollection(Of TitleInfo)
    Public Property Titles() As ObservableCollection(Of TitleInfo)
        Get
            Return _titles
        End Get
        Protected Set(ByVal value As ObservableCollection(Of TitleInfo))
            _titles = value
        End Set
    End Property

    Public Overrides Function ToString() As String
        Dim compositeAuthor As String = ""

        If Creators.Count = 0 Then
            Return "Various or Anonymous"
        End If

        For i = 0 To Me.Creators.Count - 1
            compositeAuthor &= Me.Creators(i)

            If i <> Me.Creators.Count - 1 Then
                compositeAuthor &= vbLf
            End If
        Next i
        Return compositeAuthor
    End Function

    Private Function ToCompareString() As String
        Return ToString().ToLowerInvariant()
    End Function

    Public Overloads Function Equals(ByVal that As AuthorInfo) As Boolean Implements IEquatable(Of AuthorInfo).Equals
        Return Me.ToString().Equals(that.ToString(), StringComparison.OrdinalIgnoreCase)
    End Function

    Public Function CompareTo(ByVal that As AuthorInfo) As Integer Implements IComparable(Of AuthorInfo).CompareTo
        Return Me.ToCompareString().CompareTo(that.ToCompareString())
    End Function
End Class

