﻿Imports System.ComponentModel


Public Class Bookmark
    Implements INotifyPropertyChanged, IEquatable(Of Bookmark)
    Private _label As String

    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

    Public Property Label() As String
        Set(ByVal value As String)
            If _label <> value Then
                _label = value
                OnPropertyChanged("Label")
            End If
        End Set
        Get
            Return _label
        End Get
    End Property

    Public Property ChapterTitle() As String

    Public Property CharacterOffset() As Integer

    Public Property Percentage() As Double

    Public Property DateTime() As Date

    Public Overloads Function Equals(ByVal that As Bookmark) As Boolean Implements IEquatable(Of Bookmark).Equals
        Return Me.CharacterOffset = that.CharacterOffset AndAlso Me.DateTime = that.DateTime
    End Function

    Private Sub OnPropertyChanged(ByVal propertyName As String)
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
    End Sub
End Class

