﻿Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Media


' For Transition setting
Public Class DemoPageProvider
    Implements IPageProvider
    Public Function SetPageSize(ByVal pageSize As Size) As Boolean Implements IPageProvider.SetPageSize
        Return False
    End Function

    Public Function SetFont(ByVal fontFamily As FontFamily, ByVal fontSize As Double) As Boolean Implements IPageProvider.SetFont
        Return False
    End Function

    Public Function GetPage(ByVal chapterIndex As Integer, ByVal pageIndex As Integer) As FrameworkElement Implements IPageProvider.GetPage
        Dim textBuilder As New System.Text.StringBuilder()
        textBuilder = textBuilder.Append("For a long time I used to go to bed early. Sometimes, when I had put out ").Append("my candle, my eyes would close so quickly that I had not even time to " & "say ""I'm going to sleep."" And half an hour later the thought that it was ").Append("time to go to sleep would awaken me; I would try to put away the book ").Append("which, I imagined, was still in my hands, and to blow out the light; I ").Append("had been thinking all the time, while I was asleep, of what I had just ").Append("been reading, but my thoughts had run into a channel of their own, ").Append("until I myself seemed actually to have become the subject of my book: ").Append("a church, a quartet, the rivalry between François I and Charles V. This ").Append("impression would persist for some moments after I was awake; it did not ").Append("disturb my mind, but it lay like scales upon my eyes and prevented them ").Append("from registering the fact that the candle was no longer burning. Then ").Append("it would begin to seem unintelligible, as the thoughts of a former ").Append("existence must be to a reincarnate spirit; the subject of my book would ").Append("separate itself from me, leaving me free to choose whether I would form ").Append("part of it or no; and at the same time my sight would return and I ").Append("would be astonished to find myself in a state of darkness, pleasant and ").Append("restful enough for the eyes, and even more, perhaps, for my mind, to ").Append("which it appeared incomprehensible, without a cause, a matter dark ").Append("indeed.")
        Return New TextBlock With {.FontSize = 10, .TextWrapping = TextWrapping.Wrap, .Text = textBuilder.ToString()}
    End Function

    Public Function GetPage(ByVal characterCount As Integer, <System.Runtime.InteropServices.Out()> ByRef chapterIndex As Integer, <System.Runtime.InteropServices.Out()> ByRef pageIndex As Integer) As FrameworkElement Implements IPageProvider.GetPage
        chapterIndex = 0
        pageIndex = 0
        Return GetPage(chapterIndex, pageIndex)
    End Function

    Public Function QueryLastPage(ByVal chapterIndex As Integer, <System.Runtime.InteropServices.Out()> ByRef pageIndex As Integer) As FrameworkElement Implements IPageProvider.QueryLastPage
        pageIndex = -1
        Return Nothing
    End Function

    Public Function GetLastPage(ByVal chapterIndex As Integer, <System.Runtime.InteropServices.Out()> ByRef pageIndex As Integer) As FrameworkElement Implements IPageProvider.GetLastPage
        pageIndex = -1
        Return Nothing
    End Function
End Class

