﻿Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Controls.Primitives

    Partial Public Class FindDialog
        Inherits UserControl
        Implements ITombstonable
        Public Event DialogDismissed As EventHandler(Of CancelEventArgs)
        Public Event FindText As EventHandler(Of FindTextEventArgs)

        Public Sub New()
            InitializeComponent()

            AllowFinds()

            AddHandler Loaded, Sub(sender, args)
                                   If whatTextBox.Text.Length = 0 Then
                                       whatTextBox.Focus()
                                   End If
                               End Sub
        End Sub

    Public Sub SaveState(ByVal prefix As String, ByVal state As IDictionary(Of String, Object)) Implements ITombstonable.SaveState
        state(prefix & "what") = whatTextBox.Text
        state(prefix & "matchCase") = matchCaseCheckBox.IsChecked.Value
        state(prefix & "wholeWord") = wholeWordCheckBox.IsChecked.Value
        state(prefix & "goUp") = goUpRadioButton.IsChecked.Value
    End Sub

    Public Sub RestoreState(ByVal prefix As String, ByVal state As IDictionary(Of String, Object)) Implements ITombstonable.RestoreState
        whatTextBox.Text = TryCast(state(prefix & "what"), String)
        matchCaseCheckBox.IsChecked = CBool(state(prefix & "matchCase"))
        wholeWordCheckBox.IsChecked = CBool(state(prefix & "wholeWord"))
        goUpRadioButton.IsChecked = CBool(state(prefix & "goUp"))
    End Sub

        Public Sub ShowNoMoreFinds()
            buttonHider.Visibility = Visibility.Visible
            findButton.IsEnabled = False
        End Sub

        Private Sub AllowFinds()
            If buttonHider IsNot Nothing Then
                buttonHider.Visibility = Visibility.Collapsed
            End If

            If findButton IsNot Nothing Then
                findButton.IsEnabled = whatTextBox.Text.Length > 0
            End If
        End Sub

        ' Move popup to top when the TextBox gets focus
        Private Sub OnTextBoxGotFocus(ByVal sender As Object, ByVal args As RoutedEventArgs)
            Dim popup As Popup = TryCast(Me.Parent, Popup)

            If popup IsNot Nothing Then
                popup.VerticalOffset = 0
            End If
        End Sub

        Private Sub OnTextBoxTextChanged(ByVal sender As Object, ByVal args As TextChangedEventArgs)
            AllowFinds()
        End Sub

        Private Sub OnButtonRedefineSearch(ByVal sender As Object, ByVal args As RoutedEventArgs)
            AllowFinds()
        End Sub

        Private Sub OnFindButtonClick(ByVal sender As Object, ByVal args As RoutedEventArgs)
        If FindTextEvent IsNot Nothing Then
            Dim evtArgs As FindTextEventArgs = New FindTextEventArgs With {.Text = whatTextBox.Text, .MatchCase = matchCaseCheckBox.IsChecked.Value, .WholeWord = wholeWordCheckBox.IsChecked.Value, .GoUp = goUpRadioButton.IsChecked.Value}
            RaiseEvent FindText(Me, evtArgs)
        End If
        End Sub

        Private Sub OnCancelButtonClick(ByVal sender As Object, ByVal args As RoutedEventArgs)
            RaiseEvent DialogDismissed(Me, New CancelEventArgs(True))
        End Sub
    End Class
