﻿Imports System.Collections.ObjectModel


Public Class Library
    Public Sub New()
        Me.Authors = New ObservableCollection(Of AuthorInfo)()
    End Sub

    Private _authors As ObservableCollection(Of AuthorInfo)
    Public Property Authors() As ObservableCollection(Of AuthorInfo)
        Get
            Return _authors
        End Get
        Protected Set(ByVal value As ObservableCollection(Of AuthorInfo))
            _authors = value
        End Set
    End Property

    Public Sub CreateLibraryEntry(ByVal id As Integer, ByVal titles As IList(Of String), ByVal creators As IList(Of String))
        Dim index As Integer

        ' Create AuthorInfo object from downloaded book
        Dim author As New AuthorInfo()
        For Each creator In creators
            author.Creators.Add(creator)
        Next creator

        ' Check if the library already contains that author
        If Me.Authors.Contains(author) Then
            author = Me.Authors(Me.Authors.IndexOf(author))
        Else
            ' Insert author alphabetically to author collection
            index = 0
            Do While index < Me.Authors.Count
                If author.CompareTo(Me.Authors(index)) < 0 Then
                    Me.Authors.Insert(index, author)
                    Exit Do
                End If
                index += 1
            Loop
            If index = Me.Authors.Count Then
                Me.Authors.Add(author)
            End If
        End If

        ' Create TitleInfo object from downloaded book
        Dim titleInfo As TitleInfo = New TitleInfo With {.ID = id}
        For Each title In titles
            titleInfo.Titles.Add(title)
        Next title

        ' Insert title alphabetically to title collection
        index = 0
        Do While index < author.Titles.Count
            If titleInfo.CompareTo(author.Titles(index)) = 0 Then
                author.Titles(index) = titleInfo
                Exit Do
            ElseIf titleInfo.CompareTo(author.Titles(index)) < 0 Then
                author.Titles.Insert(index, titleInfo)
                Exit Do
            End If
            index += 1
        Loop
        If index = author.Titles.Count Then
            author.Titles.Add(titleInfo)
        End If
    End Sub

    Public Function DoesLibraryEntryExist(ByVal id As Integer) As Boolean
        For Each author In Me.Authors
            For Each title In author.Titles
                If title.ID = id Then
                    Return True
                End If
            Next title
        Next author

        Return False
    End Function
End Class

