﻿Imports System.Windows.Controls
Imports System.Windows.Controls.Primitives
Imports System.Windows.Input


Public Class ManipulationThumb
    Inherits Control
    Public Event DragStarted As DragStartedEventHandler
    Public Event DragDelta As DragDeltaEventHandler
    Public Event DragCompleted As DragCompletedEventHandler

    Protected Overrides Sub OnManipulationStarted(ByVal args As ManipulationStartedEventArgs)
        If DragStartedEvent IsNot Nothing Then
            Dim evtArgs As New DragStartedEventArgs(0, 0)
            RaiseEvent DragStarted(Me, evtArgs)
        End If
        MyBase.OnManipulationStarted(args)
    End Sub

    Protected Overrides Sub OnManipulationDelta(ByVal args As ManipulationDeltaEventArgs)
        If DragDeltaEvent IsNot Nothing Then
            Dim evtArgs As New DragDeltaEventArgs(args.DeltaManipulation.Translation.X, args.DeltaManipulation.Translation.Y)
            RaiseEvent DragDelta(Me, evtArgs)
        End If
        MyBase.OnManipulationDelta(args)
    End Sub

    Protected Overrides Sub OnManipulationCompleted(ByVal args As ManipulationCompletedEventArgs)
        If DragCompletedEvent IsNot Nothing Then
            Dim evtArgs As New DragCompletedEventArgs(0, 0, False)
            RaiseEvent DragCompleted(Me, evtArgs)
        End If

        MyBase.OnManipulationCompleted(args)
    End Sub
End Class

