﻿Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Windows
Imports System.Windows.Controls


Partial Public Class OkCancelDialog
    Inherits UserControl
    Implements ITombstonable
    Public Shared ReadOnly TitleProperty As DependencyProperty = DependencyProperty.Register("Title", GetType(String), GetType(OkCancelDialog), New PropertyMetadata("", AddressOf OnTitlePropertyChanged))

    Public Shared ReadOnly MessageProperty As DependencyProperty = DependencyProperty.Register("Message", GetType(String), GetType(OkCancelDialog), New PropertyMetadata("", AddressOf OnMessagePropertyChanged))

    Public Event DialogDismissed As EventHandler(Of CancelEventArgs)

    Public Sub New()
        InitializeComponent()
    End Sub

    Public Property Title() As String
        Set(ByVal value As String)
            SetValue(TitleProperty, value)
        End Set
        Get
            Return CStr(GetValue(TitleProperty))
        End Get
    End Property

    Public Property Message() As String
        Set(ByVal value As String)
            SetValue(MessageProperty, value)
        End Set
        Get
            Return CStr(GetValue(MessageProperty))
        End Get
    End Property

    Public Sub SaveState(ByVal prefix As String, ByVal state As IDictionary(Of String, Object)) Implements ITombstonable.SaveState
        state(prefix & "title") = Me.Title
        state(prefix & "message") = Me.Message
        state(prefix & "tag") = Me.Tag
    End Sub

    Public Sub RestoreState(ByVal prefix As String, ByVal state As IDictionary(Of String, Object)) Implements ITombstonable.RestoreState
        Me.Title = TryCast(state(prefix & "title"), String)
        Me.Message = TryCast(state(prefix & "message"), String)
        Me.Tag = state(prefix & "tag")
    End Sub

    Private Shared Sub OnTitlePropertyChanged(ByVal obj As DependencyObject, ByVal args As DependencyPropertyChangedEventArgs)
        TryCast(obj, OkCancelDialog).titleTextBlock.Text = TryCast(args.NewValue, String)
    End Sub

    Private Shared Sub OnMessagePropertyChanged(ByVal obj As DependencyObject, ByVal args As DependencyPropertyChangedEventArgs)
        TryCast(obj, OkCancelDialog).messageTextBlock.Text = TryCast(args.NewValue, String)
    End Sub

    Private Sub OnCancelButtonClick(ByVal sender As Object, ByVal args As RoutedEventArgs)
        RaiseEvent DialogDismissed(Me, New CancelEventArgs(True))
    End Sub

    Private Sub OnOkButtonClick(ByVal sender As Object, ByVal args As RoutedEventArgs)
        RaiseEvent DialogDismissed(Me, New CancelEventArgs())
    End Sub
End Class
