﻿
Public NotInheritable Class StateDictionaryHelper
    Private Sub New()
    End Sub
    Public Shared Sub SafeAdd(ByVal state As IDictionary(Of String, Object), ByVal key As String, ByVal obj As Object)
        If obj Is Nothing Then
            Return
        End If

        If state.ContainsKey(key) Then
            state(key) = obj
        Else
            state.Add(key, obj)
        End If
    End Sub

    Public Shared Function SafeGet(Of T)(ByVal state As IDictionary(Of String, Object), ByVal key As String, ByVal defaultValue As T) As T
        If state.ContainsKey(key) Then
            Return CType(state(key), T)
        End If

        Return defaultValue
    End Function

    Public Shared Sub SafeRemove(ByVal state As IDictionary(Of String, Object), ByVal key As String)
        If state.ContainsKey(key) Then
            state.Remove(key)
        End If
    End Sub
End Class

