﻿Imports System.Collections.ObjectModel


Public Class TitleInfo
    Implements IComparable(Of TitleInfo)
    Public Sub New()
        Me.Titles = New ObservableCollection(Of String)()
    End Sub

    Private _titles As ObservableCollection(Of String)
    Public Property Titles() As ObservableCollection(Of String)
        Get
            Return _titles
        End Get
        Protected Set(ByVal value As ObservableCollection(Of String))
            _titles = value
        End Set
    End Property

    Public Property ID() As Integer

    Public Overrides Function ToString() As String
        Dim compositeTitle As String = ""

        For i = 0 To Me.Titles.Count - 1
            compositeTitle &= Me.Titles(i)

            If i <> Me.Titles.Count - 1 Then
                compositeTitle &= "-"
            End If
        Next i
        Return compositeTitle
    End Function

    Private Function ToCompareToString() As String
        Dim strLower As String = ToString().ToLowerInvariant()

        If strLower.StartsWith("the ") Then
            strLower = strLower.Substring(4)

        ElseIf strLower.StartsWith("an ") Then
            strLower = strLower.Substring(3)

        ElseIf strLower.StartsWith("a ") Then
            strLower = strLower.Substring(2)
        End If

        Return strLower
    End Function

    Public Function CompareTo(ByVal that As TitleInfo) As Integer Implements IComparable(Of TitleInfo).CompareTo
        Dim thisString As String = Me.ToCompareToString()
        Dim thatString As String = that.ToCompareToString()

        Dim compare As Integer = thisString.CompareTo(thatString)

        If compare = 0 Then
            Return Me.ID.CompareTo(that.ID)
        End If

        Return compare
    End Function
End Class

