﻿Imports System.Collections.Generic
Imports System.Windows
Imports System.Windows.Controls
Imports Microsoft.Phone.Tasks
Imports Petzold.Phone.EBookReader


Partial Public Class AboutControl
    Inherits UserControl
    Implements ITombstonable
    Private webBrowser As New WebBrowserTask()
    Private emailCompose As New EmailComposeTask()
    Private scrollOffset As Double = 0

    Public Sub New()
        InitializeComponent()

        AddHandler Loaded, Sub(sender, args) ScrollViewer.ScrollToVerticalOffset(scrollOffset)
    End Sub

    Public Sub SaveState(ByVal prefix As String, ByVal state As IDictionary(Of String, Object)) Implements ITombstonable.SaveState
        StateDictionaryHelper.SafeAdd(state, prefix & "scrollOffset", scrollViewer.VerticalOffset)
    End Sub

    Public Sub RestoreState(ByVal prefix As String, ByVal state As IDictionary(Of String, Object)) Implements ITombstonable.RestoreState
        scrollOffset = StateDictionaryHelper.SafeGet(state, prefix & "scrollOffset", 0.0)
    End Sub

    Private Sub OnHyperlinkButtonClick(ByVal sender As Object, ByVal args As RoutedEventArgs)
        Dim btn As Button = TryCast(sender, Button)
        webBrowser.URL = TryCast(btn.Tag, String)
        webBrowser.Show()
    End Sub

    Private Sub OnEmailButtonClick(ByVal sender As Object, ByVal args As RoutedEventArgs)
        emailCompose.To = "cp@charlespetzold.com"
        emailCompose.Subject = "Phree Book Reader"
        emailCompose.Show()
    End Sub
End Class
