﻿Imports System
Imports System.Globalization
Imports System.Windows
Imports System.Windows.Controls
Imports PhreeBookReader.CatalogServiceReference


Partial Public Class CatalogInfoControl
    Inherits UserControl
    Public Shared ReadOnly GutenbergBookProperty As DependencyProperty = DependencyProperty.Register("GutenbergBook", GetType(GutenbergBook), GetType(CatalogInfoControl), New PropertyMetadata(AddressOf OnGutenbergBookChanged))

    Public Sub New()
        InitializeComponent()
    End Sub

    Public Property GutenbergBook() As GutenbergBook
        Set(ByVal value As GutenbergBook)
            SetValue(GutenbergBookProperty, value)
        End Set
        Get
            Return CType(GetValue(GutenbergBookProperty), GutenbergBook)
        End Get
    End Property

    Private Shared Sub OnGutenbergBookChanged(ByVal obj As DependencyObject, ByVal args As DependencyPropertyChangedEventArgs)
        TryCast(obj, CatalogInfoControl).OnGutenbergBookChanged(args)
    End Sub

    Private Sub OnGutenbergBookChanged(ByVal args As DependencyPropertyChangedEventArgs)
        Dim gutenbergBook As GutenbergBook = TryCast(args.NewValue, GutenbergBook)
        Me.DataContext = gutenbergBook

        If args.NewValue IsNot Nothing Then
            languageText.Text = New CultureInfo(gutenbergBook.Language).EnglishName
            kilobyteSize.Text = (gutenbergBook.FileSize / 1024).ToString("N0")
            wordLength.Text = (1000 * (gutenbergBook.FileSize / 6000)).ToString("N0")
        End If
    End Sub
End Class
