﻿Imports System
Imports System.Windows
Imports System.Windows.Controls
Imports Microsoft.Phone.Controls
Imports Petzold.Phone.EBookReader


Partial Public Class ChaptersPage
    Inherits PhoneApplicationPage
    Private book As BookInfo = (TryCast(Application.Current, App)).CurrentBook

    Public Sub New()
        InitializeComponent()

        ' Set CurrentChapterIndex property for bolding
        For chapterIndex = 0 To book.Chapters.Count - 1
            book.Chapters(chapterIndex).IsCurrentChapter = (book.CurrentChapterIndex = chapterIndex)
        Next chapterIndex

        Me.DataContext = book
        AddHandler Loaded, AddressOf OnLoaded
    End Sub

    Private Sub OnLoaded(ByVal sender As Object, ByVal args As RoutedEventArgs)
        ' Attempt to scroll current chapter into view
        chaptersListBox.ScrollIntoView(book.Chapters(book.CurrentChapterIndex))
    End Sub

    Private Sub OnChaptersListBoxSelectionChanged(ByVal sender As Object, ByVal args As SelectionChangedEventArgs)
        Dim chapter As ChapterInfo = TryCast(chaptersListBox.SelectedItem, ChapterInfo)

        If chapter IsNot Nothing Then
            book.IsChapterAndPageInvalid = True
            book.CurrentCharacterOffset = chapter.Pages(0).AccumulatedCharacterCount
            Me.NavigationService.GoBack()
        End If
    End Sub
End Class
