﻿Imports System
Imports System.Windows.Controls
Imports System.Windows.Navigation
Imports Microsoft.Phone.Controls
Imports Petzold.Phone.EBookReader
Imports PhreeBookReader.CatalogServiceReference


Partial Public Class DisplayTitlePage
    Inherits PhoneApplicationPage
    Private bookInfo As BookInfo
    Private originalDisplayTitle As String

    Public Sub New()
        InitializeComponent()
    End Sub

    ' Load BookInfo from file
    Protected Overrides Sub OnNavigatedTo(ByVal args As NavigationEventArgs)
        ' Get book ID from query string
        Dim bookID As Integer = Int32.Parse(Me.NavigationContext.QueryString("bookid"))

        ' Load the GutenbergBook object; set to CatalogInfo
        Dim gutenbergBook As GutenbergBook = GutenbergBookExtensions.Load(bookID)
        catalogInfo.GutenbergBook = gutenbergBook

        ' Load the BookInfo; set as the DataContext for everything else
        bookInfo = BookInfo.Load(bookID)
        LayoutRoot.DataContext = bookInfo
        originalDisplayTitle = bookInfo.DisplayTitle

        MyBase.OnNavigatedTo(args)
    End Sub

    ' Save altered BookInfo to file (nothing more needs to be tombstoned)
    Protected Overrides Sub OnNavigatedFrom(ByVal args As NavigationEventArgs)
        If bookInfo.DisplayTitle <> originalDisplayTitle Then
            bookInfo.Save()
        End If
        MyBase.OnNavigatedFrom(args)
    End Sub

    Private Sub OnDisplayTitleTextChanged(ByVal sender As Object, ByVal args As TextChangedEventArgs)
        TryCast(sender, TextBox).GetBindingExpression(TextBox.TextProperty).UpdateSource()
    End Sub
End Class
