﻿Imports System.IO
Imports System.IO.IsolatedStorage
Imports System.Xml.Serialization
Imports PhreeBookReader.CatalogServiceReference


Public Module GutenbergBookExtensions
    Private Function GetFilename(ByVal bookID As Integer) As String
        Return bookID.ToString() & ".cat"
    End Function

    Public Function Load(ByVal bookID As Integer) As GutenbergBook
        Dim filename As String = GutenbergBookExtensions.GetFilename(bookID)
        Dim gutenbergBook As GutenbergBook = Nothing

        Using storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication()
            If storage.FileExists(filename) Then
                Using stream As IsolatedStorageFileStream = storage.OpenFile(filename, FileMode.Open, FileAccess.Read, FileShare.Read)
                    Dim serializer As New XmlSerializer(GetType(GutenbergBook))
                    gutenbergBook = TryCast(serializer.Deserialize(stream), GutenbergBook)
                End Using
            End If
        End Using
        Return gutenbergBook
    End Function

    <System.Runtime.CompilerServices.Extension()> _
    Public Sub Save(ByVal gutenbergBook As GutenbergBook)
        Dim filename As String = GutenbergBookExtensions.GetFilename(gutenbergBook.ID)

        Using storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication()
            Using stream As IsolatedStorageFileStream = storage.OpenFile(filename, FileMode.Create, FileAccess.Write)
                Dim serializer As New XmlSerializer(GetType(GutenbergBook))
                serializer.Serialize(stream, gutenbergBook)
            End Using
        End Using
    End Sub

    <System.Runtime.CompilerServices.Extension()> _
    Public Sub Delete(ByVal gutenbergBook As GutenbergBook, ByVal bookID As Integer)
        Dim filename As String = GutenbergBookExtensions.GetFilename(bookID)

        Using storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication()
            If storage.FileExists(filename) Then
                storage.DeleteFile(filename)
            End If
        End Using
    End Sub
End Module
